format MS COFF
public EXPORTS
section '.flat' code readable align 16

include 'vectors.inc' ;vectors functions constant

macro swap v1, v2 {
  push v1
  push v2
  pop v1
  pop v2
}

;input:
; [esp+8] = p0
; [esp+12] = p1
; [esp+16] = color
loc_0 equ byte[ebp-4]
loc_1 equ word[ebp-6]
loc_2 equ word[ebp-8]

align 4
line_brs:
  push ebp
  mov ebp,esp
  sub esp,6 ;=1+2*2
    push eax ebx ecx edx si di
    mov edx,dword[ebp+16]
;---
    mov ax,word[ebp+14] ;y1
    sub ax,word[ebp+10] ;y1-y0
    bts ax,15
    jae @f
      neg ax
      inc ax
    @@:
    and ax,0x7fff
    mov bx,word[ebp+12] ;x1
    sub bx,word[ebp+8] ;x1-x0
    bts bx,15
    jae @f
      neg bx
      inc bx
    @@:
    and bx,0x7fff

    mov byte[ebp-4],byte 0 ;bool steep=false
    cmp ax,bx
    jle @f
      mov byte[ebp-4],byte 1 ;bool steep=true
      swap word[ebp+8],word[ebp+10] ;swap(x0, y0);
      swap word[ebp+12],word[ebp+14] ;swap(x1, y1);
    @@:
    mov ax,word[ebp+8] ;x0
    cmp ax,word[ebp+12] ;if(x0>x1)
    jle @f
      swap word[ebp+8],word[ebp+12] ;swap(x0, x1);
      swap word[ebp+10],word[ebp+14] ;swap(y0, y1);
    @@:

;  int deltax  si
;  int deltay  di
;  int error  ebp-6
;  int ystep  ebp-8

    mov ax,word[ebp+8] ;x=x0
    mov si,word[ebp+12] ;x1
    sub si,ax ;deltax = x1-x0
    mov bx,si
    shr bx,1
    mov loc_1,bx ;error = deltax/2

    mov ax,word[ebp+10] ;y=y0
    mov di,word[ebp+14] ;y1
      mov loc_2,word -1 ;ystep = -1
      cmp ax,di ;if (y0<y1) ystep = 1;
      jge @f
	mov loc_2,word 1 ;ystep = 1
      @@:
    sub di,ax ;y1-y0

    bts di,15
    jae @f
      neg di
      inc di
    @@:
    and di,0x7fff ;deltay = abs(y1-y0)

    mov eax,1 ;function, draw point
    xor ebx,ebx
    xor ecx,ecx

    cmp byte[ebp-4],0
    jne .coord_yx
      mov bx,word[ebp+10] ;y0
      mov cx,word[ebp+8]  ;x0

    @@: ;for (x=x0 ; x<x1; x++) ;------------------------------------
      cmp cx,word[ebp+12]
      jg @f ;jge ???

      int 0x40
      sub loc_1,di ;error -= deltay
      cmp loc_1,0 ;if(error<0)
      jge .if0
	add bx,loc_2 ;y += ystep
	add loc_1,si ;error += deltax
      .if0:
      inc cx
      jmp @b
    @@:

      jmp .coord_end
    .coord_yx:
      mov bx,word[ebp+8]  ;x0
      mov cx,word[ebp+10] ;y0

    @@: ;for (x=x0 ; x<x1; x++) ;------------------------------------
      cmp bx,word[ebp+12]
      jg @f ;jge ???

      int 0x40
      sub loc_1,di ;error -= deltay
      cmp loc_1,0 ;if(error<0)
      jge .if1
	add cx,loc_2 ;y += ystep
	add loc_1,si ;error += deltax
      .if1:
      inc bx
      jmp @b
    @@:

    .coord_end:
;---
    pop di si edx ecx ebx eax
  mov esp,ebp ;  
  pop ebp
  ret 12




;input:
; dword[ebp+8] = pointer to contur
align 4
convert_contur:
  push ebp
  mov ebp,esp

  push ebx ecx
    mov ebx,dword[ebp+8]
    finit
;fld ...
    .new_contur:
    mov cx,word[ebx]
    btr cx,15
    jae @f
      add ebx,4
    @@:
    and cx,0xfff
    cmp cx,0
    je .end_contur
    mov eax,opr_param
    add ebx,2

    @@:
      cmp cx,0
      je .new_contur
      dec cx
	fld dword[ebx]
;        fmul st0,st1
	fistp word[eax]
;        fmul st0,st1
	fld dword[ebx+4]
	fistp word[eax+2]

 push dword[eax]
	call opred2i
	push dword[o_ang]
	pop dword[ebx] ;x(n)
	push dword[o_len]
	pop dword[ebx+4] ;y(n)

	add ebx,8 ;move next coord
      jmp @b
    .end_contur:

  pop ecx ebx ebp
  ret 4

;input:
; [esp+8] = x0,y0,a0,...
; [esp+12] = contur
; [esp+16] = color
align 4
draw_vector:
  push ebp
  mov ebp,esp
  push eax ebx ecx edx
    mov eax,dword[ebp+8]
    mov ebx,dword[ebp+12]
    mov edx,dword[ebp+16]
    finit
    fld dword[eax]  ;x0 (st3)
    fld dword[eax+4];y0 (st2)
    fld dword[eax+8];a0 (st1)

    xor cx,cx
    .new_contur:
    cmp cx,0
    je @f
      add ebx,8 ;skip one point
    @@:
    mov cx,word[ebx]
    btr cx,15
    jae @f
      mov edx,dword[ebx+2]
      add ebx,4
    @@:
    and cx,0xfff
    cmp cx,0
    je .end_contur
    add ebx,2
    @@:
      cmp cx,1
      jle .new_contur
      dec cx

      fld dword[ebx] ;st0=a(n)
      fadd st0,st1
      fcos
      fmul dword[ebx+4] ;l(n)
      fadd st0,st3
      fistp word[v_poi_0+2] ;x(n)

      fld dword[ebx] ;st0=a(n)
      fadd st0,st1
      fsin
      fmul dword[ebx+4] ;l(n)
      fadd st0,st2
      fistp word[v_poi_0] ;y(n)

      call draw_vect_point

      fld dword[ebx+8] ;st0=a(n)
      fadd st0,st1
      fcos
      fmul dword[ebx+12] ;l(n)
      fadd st0,st3
      fistp word[v_poi_1+2] ;x(n)

      fld dword[ebx+8] ;st0=a(n)
      fadd st0,st1
      fsin
      fmul dword[ebx+12] ;l(n)
      fadd st0,st2
      fistp word[v_poi_1] ;y(n)

	push dword edx ;line color
	push dword[v_poi_0]
	push dword[v_poi_1]
      call line_brs

      add ebx,8 ;move next coord
      jmp @b
    .end_contur:
  pop edx ecx ebx eax
  pop ebp
  ret 12

;input:
; ...
align 4
draw_vect_point:
  push eax ebx ecx
    mov eax,1
    xor ebx,ebx
    xor ecx,ecx
    mov bx,word[v_poi_0+2]
    mov cx,word[v_poi_0]
    int 0x40
  pop ecx ebx eax
  ret

;input:
; ebp+8  = adress int coord x
; ebp+10 = adress int coord y
align 4
opred2i:
  push ebp
  mov ebp,esp
  finit
  fild word [ebp+8]
  fmul st0,st0 ;st0=x^2
  fild word [ebp+10]
  fmul st0,st0 ;st0=y^2
  fadd st0,st1
  fsqrt
  fst dword [o_len]
  cmp dword [o_len],0
  jne @f
    mov dword [o_ang],0
    jmp .retf
  @@:
  fild word [ebp+8]
  fdiv dword [o_len]
  call acos

  cmp word [ebp+10],0
  jl @f
    fst [o_ang] ;a=acos(x/l);
    jmp .retf
  @@:

  fldpi
  fadd st0,st0 ;st0=2*pi
  fsub st0,st1 ;st0=2*pi-aac
  fst [o_ang] ;a=st0;
  .retf:
  pop ebp
  ret 4

;input:
; st0 = float value
align 4
acos:
  fld1
  fadd st, st1
  fld1
  fsub st, st2
  fmulp st1, st
  fsqrt
  fxch st1
  fpatan
  ret


o_len dd ? ;
o_ang dd ? ;   
opr_param dd ?
v_poi_0 dd ?
v_poi_1 dd ?

align 16
EXPORTS:
  dd sz_line, line_brs
  dd sz_conv, convert_contur
  dd sz_draw, draw_vector
  dd sz_opred2i, opred2i
  dd sz_o_len, o_len
  dd sz_o_ang, o_ang
  dd 0,0
  sz_line db 'vect_line',0
  sz_conv db 'vect_conv_cont',0
  sz_draw db 'vect_draw_cont',0
  sz_opred2i db 'vect_opred2i',0
  sz_o_len db 'vect_o_len',0
  sz_o_ang db 'vect_o_ang',0
